
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	TOKEN	273
#define	NUMBER	274
#define	TYPETOKEN	275
#define	ARRAY_DIM	276
#define	CCODE	277
#define	HTCODE	278
#define	PHCODE	279
#define	HCODE	280
#define	ACODE	281
#define	ATCODE	282
#define	PUBLIC	283
#define	PRIVATE	284
#define	PROTECTED	285
#define	CLASSWIDE	286
#define	ARGUMENT	287
#define	VIRTUAL	288
#define	SIGNAL	289
#define	OVERRIDE	290

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "treefuncs.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

/* destructor and initializer for variables */
static char *destructor = NULL;
static int destructor_line = 0;
static gboolean destructor_simple = TRUE;
static char *initializer = NULL;
static int initializer_line = 0;

static char *onerror = NULL;
static char *defreturn = NULL;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ", str, " at end of input", NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp, '\n')))
			*p='.';

		out=g_strconcat("Error: ", str, " before '", tmp, "'", NULL);
		g_free(tmp);
	}

	fprintf(stderr, "%s:%d: %s\n", filename, line_no, out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope, type, name, line_no,
			   destructor, destructor_line,
			   destructor_simple,
			   initializer, initializer_line);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id,
	      GString *cbuf, int line_no, int ccode_line,
	      gboolean vararg, GList *flags)
{
	Node *node;
	Type *type;
	char *c_cbuf;

	g_assert(scope != CLASS_SCOPE);
       
	if(method!=INIT_METHOD && method!=CLASS_INIT_METHOD) {
		type = pop_type();
	} else {
		type = (Type *)new_type(0,g_strdup("void"),NULL);
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data, "NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"), line_no);
	}
	if(g_list_length(gtktypes) > 2) {
		GList *li;
		for(li = gtktypes->next; li; li = li->next) {
			if(strcmp(li->data, "NONE")==0) {
				print_error(FALSE,
					    _("NONE can only appear in an "
					      "argument list by itself"),
					    line_no);
			}
		}
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope, method, type, oid, gtktypes, flags,
			  id, funcargs, onerror, defreturn, c_cbuf, line_no,
			  ccode_line, vararg);

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	onerror = NULL;
	defreturn = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
free_all_global_state(void)
{
	g_free(onerror);
	onerror = NULL;
	g_free(defreturn);
	defreturn = NULL;

	g_list_foreach(gtktypes, (GFunc)g_free, NULL);
	g_list_free(gtktypes);
	gtktypes = NULL;

	free_node_list(funcargs);
	funcargs = NULL;
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type, name, checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn,NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype),NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}

static Variable *
find_var_or_die(const char *id, int line)
{
	GList *li;
	char *s;

	for(li = class_nodes; li != NULL; li = li->next) {
		Variable *var;
		Node *node = li->data;
		if(node->type != VARIABLE_NODE)
			continue;
		var = li->data;
		if(strcmp(var->id, id)==0)
			return var;
	}

	s = g_strdup_printf(_("Variable %s not defined here"), id);
	print_error(FALSE, s, line);

	g_assert_not_reached();
	return NULL;
}

static gboolean
set_return_value(char *type, char *val)
{
	if(strcmp(type, "onerror")==0) {
		if(!onerror) {
			onerror = val;
			return TRUE;
		} else
			return FALSE;
	} else if(strcmp(type, "defreturn")==0) {
		if(!defreturn) {
			defreturn = val;
			return TRUE;
		} else
			return FALSE;
	}
	return FALSE;
}


#line 290 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		243
#define	YYFLAG		-32768
#define	YYNTBASE	50

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 87)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    48,     2,     2,     2,     2,     2,     2,    41,
    42,    44,     2,    45,    49,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    39,    47,
    40,    46,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    37,    43,    38,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    22,
    24,    27,    29,    34,    38,    43,    46,    48,    50,    52,
    54,    56,    58,    60,    62,    64,    67,    71,    74,    78,
    81,    84,    86,    88,    89,    95,   102,   114,   123,   129,
   135,   137,   141,   142,   146,   148,   150,   153,   155,   158,
   161,   164,   166,   169,   172,   174,   176,   178,   180,   183,
   185,   187,   190,   192,   195,   197,   199,   201,   203,   205,
   208,   210,   213,   215,   219,   223,   226,   228,   233,   237,
   239,   242,   244,   255,   267,   277,   287,   296,   308,   317,
   323,   326,   331,   332,   334,   337,   339,   341,   345,   347,
   351,   353,   357,   359,   362,   366,   373,   381,   384,   386,
   388,   391,   394,   398,   402,   406,   410,   412,   415
};

static const short yyrhs[] = {    52,
    53,    52,     0,    53,    52,     0,    52,    53,     0,    53,
     0,    23,     0,    26,     0,    24,     0,    25,     0,    27,
     0,    28,     0,    52,    51,     0,    51,     0,    54,    37,
    55,    38,     0,    54,    37,    38,     0,     3,    21,     4,
    21,     0,    55,    56,     0,    56,     0,    77,     0,    61,
     0,    62,     0,    39,     0,    29,     0,    30,     0,    31,
     0,    32,     0,    19,    19,     0,    19,    37,    23,     0,
    40,    86,     0,    40,    37,    23,     0,    58,    59,     0,
    59,    58,     0,    59,     0,    58,     0,     0,    57,    66,
    19,    60,    39,     0,    57,    66,    19,    22,    60,    39,
     0,    33,    64,    63,    19,    19,    37,    23,    19,    37,
    23,    39,     0,    33,    64,    63,    19,    19,    37,    23,
    39,     0,    33,    64,    63,    19,    19,     0,    19,    41,
    19,    66,    42,     0,    19,     0,    41,    65,    42,     0,
     0,    19,    43,    65,     0,    19,     0,    67,     0,     5,
    67,     0,    68,     0,    68,    71,     0,    12,    69,     0,
    11,    69,     0,    69,     0,    12,    18,     0,    11,    18,
     0,    18,     0,    17,     0,    16,     0,    19,     0,    70,
    19,     0,    21,     0,     6,     0,    13,    15,     0,    13,
     0,    14,    15,     0,    14,     0,    15,     0,     9,     0,
     8,     0,     7,     0,    44,    71,     0,    44,     0,    19,
    74,     0,    74,     0,    57,    19,    74,     0,    19,    57,
    74,     0,    57,    74,     0,    72,     0,    19,    41,    75,
    42,     0,    75,    45,    19,     0,    19,     0,    37,    23,
     0,    39,     0,    35,    64,    73,    66,    19,    41,    80,
    42,    78,    76,     0,    57,    35,    64,    72,    66,    19,
    41,    80,    42,    78,    76,     0,    34,    57,    66,    19,
    41,    80,    42,    78,    76,     0,    57,    34,    66,    19,
    41,    80,    42,    78,    76,     0,    34,    66,    19,    41,
    80,    42,    78,    76,     0,    36,    41,    21,    42,    66,
    19,    41,    80,    42,    78,    76,     0,    57,    66,    19,
    41,    80,    42,    78,    76,     0,    19,    41,    19,    42,
    76,     0,    19,    79,     0,    19,    79,    19,    79,     0,
     0,    86,     0,    37,    23,     0,     6,     0,    19,     0,
    19,    45,    81,     0,    81,     0,    82,    45,    10,     0,
    82,     0,    82,    45,    83,     0,    83,     0,    66,    19,
     0,    66,    19,    22,     0,    66,    19,    41,    19,    84,
    42,     0,    66,    19,    22,    41,    19,    84,    42,     0,
    84,    85,     0,    85,     0,    19,     0,    46,    86,     0,
    47,    86,     0,    46,    40,    86,     0,    47,    40,    86,
     0,    40,    40,    86,     0,    48,    40,    86,     0,    20,
     0,    49,    20,     0,    19,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   308,   309,   310,   311,   314,   320,   326,   332,   338,   344,
   352,   353,   356,   361,   368,   373,   374,   377,   378,   379,
   380,   383,   384,   385,   386,   389,   402,   418,   422,   430,
   431,   432,   433,   434,   440,   443,   447,   482,   510,   580,
   589,   595,   596,   599,   602,   608,   609,   617,   621,   628,
   631,   634,   637,   640,   643,   646,   649,   652,   655,   659,
   662,   667,   670,   673,   676,   679,   684,   687,   690,   695,
   696,   700,   712,   718,   730,   742,   745,   751,   756,   759,
   764,   765,   769,   785,   801,   817,   833,   844,   850,   860,
   881,   892,   911,   917,   918,   924,   925,   936,   946,   949,
   950,   953,   954,   957,   960,   963,   971,   981,   982,   985,
   998,  1002,  1006,  1010,  1014,  1018,  1024,  1025,  1029
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","TOKEN","NUMBER","TYPETOKEN","ARRAY_DIM",
"CCODE","HTCODE","PHCODE","HCODE","ACODE","ATCODE","PUBLIC","PRIVATE","PROTECTED",
"CLASSWIDE","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE","'{'","'}'","';'","'='",
"'('","')'","'|'","'*'","','","'>'","'<'","'!'","'-'","prog","ccode","ccodes",
"class","classdec","classcode","thing","scope","destructor","initializer","varoptions",
"variable","argument","argtype","flags","flaglist","type","type1","type2","integer",
"tspecifier","stars","simplesigtype","fullsigtype","sigtype","tokenlist","codenocode",
"method","returnvals","retcode","funcargs","arglist","arglist1","arg","checklist",
"check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    50,    50,    50,    50,    51,    51,    51,    51,    51,    51,
    52,    52,    53,    53,    54,    55,    55,    56,    56,    56,
    56,    57,    57,    57,    57,    58,    58,    59,    59,    60,
    60,    60,    60,    60,    61,    61,    62,    62,    62,    63,
    63,    64,    64,    65,    65,    66,    66,    67,    67,    68,
    68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
    68,    69,    69,    69,    69,    69,    70,    70,    70,    71,
    71,    72,    72,    73,    73,    73,    73,    74,    75,    75,
    76,    76,    77,    77,    77,    77,    77,    77,    77,    77,
    78,    78,    78,    79,    79,    80,    80,    80,    80,    81,
    81,    82,    82,    83,    83,    83,    83,    84,    84,    85,
    85,    85,    85,    85,    85,    85,    86,    86,    86
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     4,     3,     4,     2,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     2,     3,     2,     3,     2,
     2,     1,     1,     0,     5,     6,    11,     8,     5,     5,
     1,     3,     0,     3,     1,     1,     2,     1,     2,     2,
     2,     1,     2,     2,     1,     1,     1,     1,     2,     1,
     1,     2,     1,     2,     1,     1,     1,     1,     1,     2,
     1,     2,     1,     3,     3,     2,     1,     4,     3,     1,
     2,     1,    10,    11,     9,     9,     8,    11,     8,     5,
     2,     4,     0,     1,     2,     1,     1,     3,     1,     3,
     1,     3,     1,     2,     3,     6,     7,     2,     1,     1,
     2,     2,     3,     3,     3,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,     9,    10,    12,     0,     4,
     0,     0,    11,     3,     2,     0,     0,     1,     0,    22,
    23,    24,    25,    43,     0,    43,     0,    14,    21,     0,
    17,     0,    19,    20,    18,    15,     0,     0,     0,     0,
    61,    69,    68,    67,     0,     0,    63,    65,    66,    57,
    56,    55,    58,    60,     0,     0,    46,    48,    52,     0,
     0,     0,    13,    16,     0,    43,     0,     0,    45,     0,
    41,     0,    47,    54,    51,    53,    50,    62,    64,     0,
     0,    71,    49,    59,     0,     0,    77,     0,    73,     0,
     0,     0,    34,     0,     0,    42,     0,     0,     0,     0,
    70,     0,     0,     0,    72,     0,    76,     0,     0,     0,
     0,     0,     0,    34,     0,     0,    33,    32,     0,     0,
    82,    90,    44,     0,    39,     0,    61,    58,     0,     0,
    99,   101,   103,    80,     0,    75,    74,     0,     0,     0,
     0,    26,     0,     0,   119,   117,     0,     0,    28,     0,
    30,    31,    35,    81,     0,     0,     0,     0,   104,    93,
     0,    78,     0,     0,     0,     0,     0,    27,    36,    29,
   118,    93,    40,     0,    93,    98,   105,     0,     0,     0,
   100,   102,    79,     0,     0,    93,     0,     0,     0,    38,
     0,     0,     0,     0,    91,    94,    87,    93,     0,     0,
     0,    89,     0,    85,     0,   110,     0,     0,     0,     0,
     0,   109,    95,     0,     0,    93,    86,    93,     0,     0,
     0,     0,   111,     0,   112,     0,   106,   108,    92,    83,
     0,     0,    37,   107,   115,   113,   114,   116,    88,    84,
     0,     0,     0
};

static const short yydefgoto[] = {   241,
     8,     9,    10,    11,    30,    31,    32,   117,   118,   119,
    33,    34,    72,    39,    70,   129,    57,    58,    59,    60,
    83,    87,    88,    89,   135,   122,    35,   180,   195,   130,
   131,   132,   133,   211,   212,   196
};

static const short yypact[] = {   158,
    13,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   158,   185,
   -26,    44,-32768,   185,   185,   168,    51,   185,    33,-32768,
-32768,-32768,-32768,    43,   138,    43,    46,-32768,-32768,   186,
-32768,   107,-32768,-32768,-32768,-32768,    67,    71,    82,   271,
-32768,-32768,-32768,-32768,   176,   280,    95,   102,-32768,-32768,
-32768,-32768,-32768,-32768,   238,   108,-32768,    86,-32768,   112,
    73,   111,-32768,-32768,   238,    43,   114,    92,   105,    96,
   121,   144,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   145,
   131,    86,-32768,-32768,   147,   154,-32768,   238,-32768,   133,
   161,   177,   152,    41,    71,-32768,   195,   204,   200,   255,
-32768,   207,   239,   246,-32768,     1,-32768,   256,   238,   240,
     1,   238,     8,   -10,    -5,   255,   155,   272,   257,   274,
-32768,-32768,-32768,   238,   262,   255,   258,    20,   282,   260,
-32768,   259,-32768,-32768,    34,-32768,-32768,   264,   284,   255,
   287,-32768,   285,   268,-32768,-32768,   286,   290,-32768,   269,
-32768,-32768,-32768,-32768,   270,   291,   273,   238,    -3,   294,
   221,-32768,   297,   255,   276,   277,   279,-32768,-32768,-32768,
-32768,   294,-32768,   -15,   294,-32768,   281,   299,    -2,    41,
-32768,-32768,-32768,   283,   255,   294,   255,    41,   289,-32768,
    41,   302,    89,   300,   305,-32768,-32768,   294,   288,    41,
   292,-32768,   304,-32768,    89,-32768,   293,     3,     9,   295,
    35,-32768,-32768,    -2,    41,   294,-32768,   294,   298,    49,
    17,    17,-32768,    17,-32768,    17,-32768,-32768,-32768,-32768,
    41,    41,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   328,   329,-32768
};

static const short yypgoto[] = {-32768,
    52,    45,   322,-32768,-32768,   306,   -22,   214,   222,   224,
-32768,-32768,-32768,   -20,   245,   -24,   301,-32768,    53,-32768,
   261,   250,-32768,    54,-32768,  -175,-32768,  -165,   130,  -114,
   187,-32768,   188,   141,  -151,  -115
};


#define	YYLAST		349


static const short yytable[] = {   149,
    56,   150,    55,   189,   197,    61,   188,    67,   113,   191,
    16,   157,   202,   145,   146,   204,   145,   146,   177,   102,
   200,   145,   146,   190,   217,   166,   142,   145,   146,   115,
    80,   147,   215,    12,   194,   145,   146,   178,    86,   230,
    91,   103,   222,   148,   143,    92,   148,    17,   224,   184,
   231,   148,   232,   206,    15,   239,   240,   148,    18,   228,
    13,   -97,   104,   108,   158,   148,    13,   206,   228,    13,
   199,    36,   201,    37,   207,   162,   227,   120,   163,   121,
   208,   209,   210,    38,   139,    68,    62,   141,   207,    69,
   234,    85,   223,   225,   208,   209,   210,    75,    77,   155,
    71,    20,    21,    22,    23,   235,   236,   206,   237,    78,
   238,    40,    41,    42,    43,    44,    79,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    81,    54,   207,    82,
    84,    90,    93,    94,   208,   209,   210,    96,   105,   107,
    65,    66,    40,    41,    42,    43,    44,    95,    45,    46,
    47,    48,    49,    50,    51,    52,    53,   136,    54,   137,
     1,    97,    98,    99,   105,   102,    20,    21,    22,    23,
   113,   100,   106,   114,   109,    20,    21,    22,    23,   110,
     2,     3,     4,     5,     6,     7,    19,   103,    47,    48,
    49,   115,   116,    74,   115,   111,    20,    21,    22,    23,
    24,    25,    26,    27,    19,    28,    29,     2,     3,     4,
     5,     6,     7,   124,    20,    21,    22,    23,    24,    25,
    26,    27,   125,    63,    29,    40,    41,    42,    43,    44,
   181,    45,    46,    47,    48,    49,    50,    51,    52,    53,
   126,    54,    40,    41,    42,    43,    44,   103,    45,    46,
    47,    48,    49,    50,    51,    52,    53,   134,    54,    40,
   127,    42,    43,    44,   102,    45,    46,    47,    48,    49,
    50,    51,    52,   128,   138,    54,    41,    42,    43,    44,
   140,    45,    46,    47,    48,    49,    50,    51,    52,    53,
   113,    54,    47,    48,    49,   153,   154,    76,   156,   -96,
   159,   160,   165,   161,   164,   167,   169,   168,   170,   171,
   172,   173,   179,   174,   175,   183,   185,   193,   186,   187,
   205,   192,   213,   214,   198,   203,   219,   242,   243,   216,
    14,   152,   221,   218,   226,    64,   233,   144,   151,   123,
    73,   112,   101,   229,   176,   220,     0,     0,   182
};

static const short yycheck[] = {   115,
    25,   116,    25,    19,   180,    26,   172,    32,    19,   175,
    37,   126,   188,    19,    20,   191,    19,    20,    22,    19,
   186,    19,    20,    39,   200,   140,    19,    19,    20,    40,
    55,    37,   198,    21,    37,    19,    20,    41,    61,   215,
    65,    41,    40,    49,    37,    66,    49,     4,    40,   164,
   216,    49,   218,    19,    10,   231,   232,    49,    14,   211,
     9,    42,    85,    88,    45,    49,    15,    19,   220,    18,
   185,    21,   187,    41,    40,    42,    42,    37,    45,    39,
    46,    47,    48,    41,   109,    19,    41,   112,    40,    19,
    42,    19,   208,   209,    46,    47,    48,    45,    46,   124,
    19,    29,    30,    31,    32,   221,   222,    19,   224,    15,
   226,     5,     6,     7,     8,     9,    15,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    19,    21,    40,    44,
    19,    21,    19,    42,    46,    47,    48,    42,    85,    86,
    34,    35,     5,     6,     7,     8,     9,    43,    11,    12,
    13,    14,    15,    16,    17,    18,    19,   104,    21,   106,
     3,    41,    19,    19,   111,    19,    29,    30,    31,    32,
    19,    41,    19,    22,    42,    29,    30,    31,    32,    19,
    23,    24,    25,    26,    27,    28,    19,    41,    13,    14,
    15,    40,    41,    18,    40,    19,    29,    30,    31,    32,
    33,    34,    35,    36,    19,    38,    39,    23,    24,    25,
    26,    27,    28,    19,    29,    30,    31,    32,    33,    34,
    35,    36,    19,    38,    39,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    41,    21,     5,     6,     7,     8,     9,    41,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    19,    21,     5,
     6,     7,     8,     9,    19,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    19,    21,     6,     7,     8,     9,
    41,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    19,    21,    13,    14,    15,    39,    23,    18,    37,    42,
    19,    42,    19,    45,    41,    19,    39,    23,    23,    20,
    42,    42,    19,    23,    42,    19,    41,    19,    42,    41,
    19,    41,    23,    19,    42,    37,    23,     0,     0,    42,
     9,   118,    40,    42,    40,    30,    39,   114,   117,    95,
    40,    92,    82,   214,   158,   205,    -1,    -1,   161
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 308 "parse.y"
{ ; ;
    break;}
case 2:
#line 309 "parse.y"
{ ; ;
    break;}
case 3:
#line 310 "parse.y"
{ ; ;
    break;}
case 4:
#line 311 "parse.y"
{ ; ;
    break;}
case 5:
#line 314 "parse.y"
{
			Node *node = new_ccode(C_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 320 "parse.y"
{
			Node *node = new_ccode(H_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 326 "parse.y"
{
			Node *node = new_ccode(HT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 332 "parse.y"
{
			Node *node = new_ccode(PH_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 338 "parse.y"
{
			Node *node = new_ccode(A_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 10:
#line 344 "parse.y"
{
			Node *node = new_ccode(AT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 11:
#line 352 "parse.y"
{ ; ;
    break;}
case 12:
#line 353 "parse.y"
{ ; ;
    break;}
case 13:
#line 356 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 14:
#line 361 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 15:
#line 368 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 16:
#line 373 "parse.y"
{ ; ;
    break;}
case 17:
#line 374 "parse.y"
{ ; ;
    break;}
case 18:
#line 377 "parse.y"
{ ; ;
    break;}
case 19:
#line 378 "parse.y"
{ ; ;
    break;}
case 20:
#line 379 "parse.y"
{ ; ;
    break;}
case 21:
#line 380 "parse.y"
{ ; ;
    break;}
case 22:
#line 383 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 23:
#line 384 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 24:
#line 385 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 25:
#line 386 "parse.y"
{ the_scope = CLASS_SCOPE; ;
    break;}
case 26:
#line 389 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "destroywith")==0) {
				g_free(yyvsp[-1].id);
				destructor = yyvsp[0].id;
				destructor_line = line_no;
				destructor_simple = TRUE;
			} else {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
				;
    break;}
case 27:
#line 402 "parse.y"
{
			if(strcmp(yyvsp[-2].id, "destroy")==0) {
				g_free(yyvsp[-2].id);
				destructor = (yyvsp[0].cbuf)->str;
				g_string_free(yyvsp[0].cbuf, FALSE);
				destructor_line = ccode_line;
				destructor_simple = FALSE;
			} else {
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf, TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 28:
#line 418 "parse.y"
{
			initializer = yyvsp[0].id;
			initializer_line = ccode_line;
				;
    break;}
case 29:
#line 422 "parse.y"
{
			initializer = (yyvsp[0].cbuf)->str;
			initializer_line = ccode_line;
			g_string_free(yyvsp[0].cbuf, FALSE);
				;
    break;}
case 30:
#line 430 "parse.y"
{ ; ;
    break;}
case 31:
#line 431 "parse.y"
{ ; ;
    break;}
case 32:
#line 432 "parse.y"
{ destructor = NULL; ;
    break;}
case 33:
#line 433 "parse.y"
{ initializer = NULL; ;
    break;}
case 34:
#line 434 "parse.y"
{
			destructor = NULL;
			initializer = NULL;
					;
    break;}
case 35:
#line 440 "parse.y"
{
			push_variable(yyvsp[-2].id, the_scope,yyvsp[-4].line, NULL);
						;
    break;}
case 36:
#line 443 "parse.y"
{
			push_variable(yyvsp[-3].id, the_scope, yyvsp[-5].line, yyvsp[-2].id);
						;
    break;}
case 37:
#line 447 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 38:
#line 482 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    NULL,0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,(yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 39:
#line 510 "parse.y"
{
			Node *node;
			char *get, *set = NULL;
			Variable *var;
			Type *type;
			char *root;
			
			if(strcmp(yyvsp[0].id, "link")!=0 &&
			   strcmp(yyvsp[0].id, "stringlink")!=0 &&
			   strcmp(yyvsp[0].id, "objectlink")!=0) {
				g_free(yyvsp[0].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id);
				g_list_foreach(yyvsp[-3].list,(GFunc)g_free,NULL);
				yyerror(_("parse error"));
				YYERROR;
			}

			type = pop_type();

			var = find_var_or_die(yyvsp[-1].id, yyvsp[-4].line);
			if(var->scope == PRIVATE_SCOPE)
				root = "self->_priv";
			else if(var->scope == CLASS_SCOPE)
				root = "SELF_CLASS(GTK_OBJECT(self)->klass)";
			else
				root = "self";

			if(strcmp(yyvsp[0].id, "link")==0) {
				set = g_strdup_printf("%s->%s = ARG;",
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id, "stringlink")==0) {
				set = g_strdup_printf("g_free(%s->%s); "
						      "%s->%s = g_strdup(ARG);",
						      root, yyvsp[-1].id,
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id, "objectlink")==0) {
				set = g_strdup_printf(
				  "if(%s->%s) "
				   "gtk_object_unref(GTK_OBJECT(%s->%s)); "
				  "%s->%s = ARG; "
				  "if(%s->%s) "
				   "gtk_object_ref(GTK_OBJECT(%s->%s));",
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id);
			} else {
				g_assert_not_reached();
			}

			/* get is the same for everything */
			get = g_strdup_printf("ARG = %s->%s;", root, yyvsp[-1].id);

			g_free(yyvsp[0].id);


			if(!type)
				type = copy_type(var->vtype);

			node = new_argument(yyvsp[-2].id, type, yyvsp[-3].list,
					    yyvsp[-1].id, get, yyvsp[-4].line,
					    set, yyvsp[-4].line, yyvsp[-4].line);
			class_nodes = g_list_append(class_nodes,node);
						;
    break;}
case 40:
#line 580 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 41:
#line 589 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 42:
#line 595 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 43:
#line 596 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 44:
#line 599 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 45:
#line 602 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 46:
#line 608 "parse.y"
{ ; ;
    break;}
case 47:
#line 609 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 48:
#line 617 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id,NULL);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 49:
#line 621 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id,NULL);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 50:
#line 628 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 51:
#line 631 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 52:
#line 634 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 53:
#line 637 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 54:
#line 640 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 55:
#line 643 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 56:
#line 646 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 57:
#line 649 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 58:
#line 652 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 59:
#line 655 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 60:
#line 659 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 61:
#line 662 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 62:
#line 667 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 63:
#line 670 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 64:
#line 673 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 65:
#line 676 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 66:
#line 679 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 67:
#line 684 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 68:
#line 687 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 69:
#line 690 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 70:
#line 695 "parse.y"
{ stars++; ;
    break;}
case 71:
#line 696 "parse.y"
{ stars++; ;
    break;}
case 72:
#line 700 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id, "last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 73:
#line 712 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 74:
#line 718 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 75:
#line 730 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 76:
#line 742 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 77:
#line 745 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 78:
#line 751 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes, yyvsp[-3].id);
						;
    break;}
case 79:
#line 756 "parse.y"
{
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
						;
    break;}
case 80:
#line 759 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
       						;
    break;}
case 81:
#line 764 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 82:
#line 765 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 83:
#line 769 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 84:
#line 785 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 85:
#line 801 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-8].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 86:
#line 817 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 87:
#line 833 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 88:
#line 844 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[0].cbuf,
				      yyvsp[-10].line, ccode_line,
				      vararg, NULL);
									;
    break;}
case 89:
#line 850 "parse.y"
{
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line, ccode_line,
				      vararg, NULL);
								;
    break;}
case 90:
#line 860 "parse.y"
{
			if(strcmp(yyvsp[-4].id, "init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else if(strcmp(yyvsp[-4].id, "class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[-2].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 91:
#line 881 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 92:
#line 892 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-3].id, yyvsp[-2].id)) {
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				onerror = defreturn = NULL;
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-3].id);
			g_free(yyvsp[-1].id);
						;
    break;}
case 93:
#line 911 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
					;
    break;}
case 94:
#line 917 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 95:
#line 918 "parse.y"
{
			yyval.id = (yyvsp[1].cbuf)->str;
			g_string_free(yyvsp[1].cbuf, FALSE);
					;
    break;}
case 96:
#line 924 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 97:
#line 925 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 98:
#line 936 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 99:
#line 946 "parse.y"
{ has_self = FALSE; ;
    break;}
case 100:
#line 949 "parse.y"
{ vararg = TRUE; ;
    break;}
case 101:
#line 950 "parse.y"
{ vararg = FALSE; ;
    break;}
case 102:
#line 953 "parse.y"
{ ; ;
    break;}
case 103:
#line 954 "parse.y"
{ ; ;
    break;}
case 104:
#line 957 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 105:
#line 960 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 106:
#line 963 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 107:
#line 971 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 108:
#line 981 "parse.y"
{ ; ;
    break;}
case 109:
#line 982 "parse.y"
{ ; ;
    break;}
case 110:
#line 985 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 111:
#line 998 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 112:
#line 1002 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 113:
#line 1006 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 114:
#line 1010 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 115:
#line 1014 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 116:
#line 1018 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 117:
#line 1024 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 118:
#line 1025 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 119:
#line 1029 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1032 "parse.y"

